﻿"use strict";
var calendarWidget;
var weekDays =['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
var monthNames = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 
'August', 'September', 'October', 'November', 'December'];
var currentMonth = (new Date()).getMonth();
var currentYear = (new Date()).getFullYear();
var selectedDate = new Date();
$(document).ready(function () {
	
	//Setup the input tags to display calendar by binding to their focus event
	$("input[data-calendar]").on("focus", function (event) {

		var element = event.target || event.srcElement;
		
		//Display calendar if the inputs receive focus or are clicked
		if(calendarWidget){
			
			updateCalendar(element, element.value);
		}else{

			createCalendar(element, element.value);			
		}
		showCalendar(element);
		
	});	
	$(document).on("click", function(event){
		var element = event.target|| event.srcElement;
		if($.contains($("#wcg-modal")[0], $(element)[0]) == false &&
		$(element).is("input[data-calendar]") == false){
			hideCalendar(element);
		} else if($(element).hasClass("activeDate") == true){
			setInputValue($(element));
		} else if($(element).hasClass("leftChevron") ==  true){
			changeMonth(element, -1);
		} else if ($(element).hasClass("rightChevron") == true){
			changeMonth(element, 1);
		} else if ($.contains($("#wcg-modal")[0], $(element)[0]) == true &&
		$(element).hasClass("glyphicon-chevron-left")){
			changeMonth(element, -1);
		} else if($.contains($("#wcg-modal")[0], $(element)[0]) &&
		$(element).hasClass("glyphicon-chevron-right")){
			changeMonth(element, 1);
		}

	});
});
function setInputValue(element){
		selectedDate = new Date(currentYear, currentMonth, $(element).text());
		$(calendarWidget['selectedElement']).val(selectedDate.getMonth() + 1 + '/' + 
		selectedDate.getDate() +'/'+ selectedDate.getFullYear());
		$(calendarWidget).find(".selected").removeClass("selected");
		$(element).addClass("selected");
	};
function changeMonth(ctrl, month){
	var currentValue = new Date(currentYear,  currentMonth, selectedDate.getDate());
	updateCalendar(ctrl, currentValue.setMonth(currentValue.getMonth() + month));
}
function showCalendar(element){
	calendarWidget["element"] = element;
	$(calendarWidget).modal('show');
}
function hideCalendar(element){
	
	$(calendarWidget).modal('hide');
}

function updateCalendar(element, date){
	var calendarDate = date? new Date(date): new Date();
	$(calendarWidget).find("#monthYear").first().text(calendarDate.toString());	
	$("#dateChart").find("tbody").first().replaceWith(getDateTable(calendarDate));

	currentMonth = calendarDate.getMonth();
	currentYear = calendarDate.getFullYear();
	selectedDate = calendarDate;
}
function createCalendar(element, date) {
	
	var calendarDate = date == true? new Date(date): new Date();	
	var calendarDiv = $('<div id="wcg-modal" class="modal fade" ' +
	'data-backdrop="false" role="dialog" >' +
	'<div class="modal-dialog modal-sm" role="document" >' +
	'<div class="modal-content" >' +
	'<div class="modal-body" ></div></div></div></div>');
	var infoDiv = $('<div class="container-fluid" ><div class="row" ></div></div>');
	var leftChevron = $('<button type="button" class="leftChevron btn-info col-xs-3" >' +
	'<span class="glyphicon glyphicon-chevron-left" ></span></button>');
	var rightChevron = $('<button type="button" class="rightChevron btn-info col-xs-3" >' +
	'<span class="glyphicon glyphicon-chevron-right"></span></button>');
	var monthYear = $('<span id="monthYear" class="col-xs-6" >' + 
	calendarDate.toString() + '</span>');
	var dateChart = $('<table id="dateChart" class="table table-condensed '+
	'table-hover table-bordered" ></table>');
	var weekdayTitleRow = $('<thead id="weekdayTitles" ><tr></tr></thead>');	
	weekDays.forEach(function(item, index){
		$(weekdayTitleRow).find("tr").first().append($('<th>' + item + '</th>'));
	});
	$(infoDiv).find(".row").first().append(leftChevron);
	$(infoDiv).find(".row").first().append(monthYear);
	$(infoDiv).find(".row").first().append(rightChevron);
	$(calendarDiv).find(".modal-body").first().html(infoDiv);
	$(dateChart).append(weekdayTitleRow);
	$(dateChart).append(getDateTable(calendarDate));
	$(calendarDiv).find(".modal-body").first().append(dateChart);		
	calendarWidget = $(calendarDiv);
	
	$(document.body).append(calendarWidget);
	
	//Place the calendar under the correct input tag
	$(calendarWidget).css({
		left: $(element).position().left + "px",
		top: $(element).position().top + $(element).height() + 8 + "px"
	});
	calendarWidget["selectedElement"] = $(element);
	currentMonth = calendarDate.getMonth();
	currentYear = calendarDate.getFullYear();
	selectedDate = calendarDate;
};

function getDateTable(date){
	var fullDate = date;
	var selectedMonth = date.getMonth();
	var dateTable = $("<tbody></tbody>");
	var startDate = new Date(fullDate.getFullYear(),  fullDate.getMonth(), 1);
	do {
		startDate.setDate(startDate.getDate() - 1);
		
	}while(startDate.getDay() > 0)
	for(var j = 0 ; j < 6; j++){
		$(dateTable).append($("<tr></tr>"));
		var row = $(dateTable).find("tr").last();
		for(var i = 0; i <  7; i++){
			if(selectedMonth === startDate.getMonth()){
				row.append($('<td class="activeDate" >' + startDate.getDate() + '</td>'));
			} else {
				row.append($('<td class="inactiveDate" >' + startDate.getDate() + '</td>'));
			}
			
			startDate.setDate(startDate.getDate() + 1);
		}		
	}
	
	return dateTable;
		
}

Date.prototype.toString = function(){
	
		var formattedDate = monthNames[this.getMonth()];
		formattedDate += (" " + this.getFullYear());
		return formattedDate;	
}